var Fis11000_CompraLegalBa_Controller = function(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZhFilterPreferences, ZHPromise, restEngine){
    
    var self = this;
    var errorMessageExport = '';
    
    self.addAgendamento = function(widget){
        widget.newRow(); 
        widget.getField('DTREFINI').isVisible = true;
    };
    
    self.cancelAgendamento = function(args){
        General.backOrCancel(args); 
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };
    
    self.editAgendamento = function(widget){
        General.edit(widget); 
        this.periodicidadeOnChange(widget);
    };
    
    self.saveAgendamento = function(widget){
        if (widget.isValid()) {
		    var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));
            
            if(d1.getTime() > d2.getTime()){
                if(((widget.currentRow.CDINSCESTA == '') || (widget.currentRow.CDINSCESTA == null)) && (widget.currentRow.CDEMPRESA)){
                    widget.currentRow.CDINSCESTA = "T";
                }
                
                widget.currentRow.NRORG = getLocalVar('NRORG');
                
                General.callRestEngine('fis_acessorias#/saveAgendamentoCompraLegalBa','Row', widget.currentRow).then(
                    function(success){
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Agendado com sucesso.');
                        ScreenService.goBack();
                        widget.getField('DTREFINI').isVisible = true;
                        widget.reload();
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
		    } else {
		        ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
		    }
            
        } else {
			// @todo create messages class
			ScreenService.showMessage("Preencha todos os campos corretamente!");
		}
    };
    
    self.downloadArquivoAgendado = function(compraLegalBaWidget) {
        var downloadRoute;
        var fileName;
        
        if(compraLegalBaWidget.hasCheckedRows()){
            var rows = compraLegalBaWidget.getCheckedRows();
            rows.forEach(function(row){
                downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;
                
                window.open(downloadRoute + fileName);
            });
        } 
        else {
            var row = compraLegalBaWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;
            
            window.open(downloadRoute + fileName);
        }
        
    };
    
    self.deleteAgendamento = function(widget){
        widget.currentRow.NRORG = getLocalVar('NRORG');
        
        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
        	General.callRestEngine('fis_acessorias#/deleteAgendamentoCompraLegalBa','Row', widget.currentRow).then(
                function(success){
                    ScreenService.showMessage('Deletado com sucesso.');
                    ScreenService.goBack();
                    widget.reload();
                },
                function(error){
                    ScreenService.showMessage(error.data.error);
                }
            );
        });
    };

    self.periodicidadeOnChange = function(widget){
        if(widget.currentRow.IDPERIAGEN == 0){
            widget.getField('DTREFINI').isVisible = true;
        }
        else if(widget.currentRow.IDPERIAGEN == 1){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        }
        else if(widget.currentRow.IDPERIAGEN == 2){
            widget.getField('DTREFINI').isVisible = false;
            if((widget.currentRow.DTAGENDAMENTO) && widget.currentRow.DTAGENDAMENTO != ""){
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    
    /**
     * Função para a chamada de Exportação
     */
    self.exportarCompraLegalBa = function(compraLegalBaWidgetGrid){
        errorMessageExport = '';
        var lista = '';
        
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if(compraLegalBaWidgetGrid.isValid() && compraLegalBaWidgetGrid.getParent().isValid()){ 
            if(compraLegalBaWidgetGrid.hasCheckedRows() == true){
                General.callRestEngine('fis_acessorias#/saveListaCompraLegalBa','DataSet', compraLegalBaWidgetGrid.getCheckedRows()).then(
                    function(success){
                        var distInscEst = [];
                        var map = new Map();
                        compraLegalBaWidgetGrid.getCheckedRows().forEach(function(item) {
                            if(!map.has(item.CDINSCESTA)){
                                map.set(item.CDINSCESTA, true);    // set any value to Map
                                distInscEst.push({
                                    CDINSCESTA: item.CDINSCESTA
                                });
                            }
                        });
                        //[...new Set(compraLegalBaWidgetGrid.getCheckedRows().map(row => row.CDINSCESTA))];
                        distInscEst.forEach(function(inscrestad, index, array){
                            
                            compraLegalBaWidgetGrid.appliedFilter.FILTER_ROW.NRORG = getLocalVar('NRORG');
                            lista = success.dataset.columnsToReturn.NRLISTA;
                          
                            var row = {
                                'header': compraLegalBaWidgetGrid.getParent().currentRow,
                                'filter': compraLegalBaWidgetGrid.appliedFilter.FILTER_ROW,
                                'nrlista': success.dataset.columnsToReturn.NRLISTA,
                                'inscrestad': inscrestad.CDINSCESTA
                            };
                            var route = 'fis#/exportarCompraLegalBa';
                            
                            var message = Messages_fiscal.EXPORTANDO_COMPRA_LEGAL_BA;
                            
                            self.exportarArquivo(row, route, message).then(function(success){
                                General.callRestEngine('fis_acessorias#/deleteListaCompraLegalBa','Row', { 'NRLISTA': lista });
                                if((errorMessageExport !== '')){
                                    ScreenService.showMessage(errorMessageExport);
                                }
                            }, function(error){
                                General.callRestEngine('fis_acessorias#/deleteListaCompraLegalBa','Row', { 'NRLISTA': lista });
                                if((errorMessageExport !== '')){
                                    ScreenService.showMessage(errorMessageExport);
                                }
                            });
                            
                        });
                    },
                    function(error){
                        ScreenService.showMessage(error.data.error);
                    }
                );
            } else {
                ScreenService.showMessage("Selecione no mínimo uma nota fiscal.");
            }
        }
    };
    
    self.onChangeEmpresa = function(compraLegalBaWidget){
        if(compraLegalBaWidget.currentRow.CDEMPRESA)
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('compra_legal_ba_grid'));
    };
    
    self.onEnterCompraLegal = function() {
        templateManager.container.getWidget('compra_legal_ba_grid').activate();
    };
    
    self.aplicaDataSourceFilter = function(){
        var widgetFiltro = templateManager.container.getActiveWidget().currentRow;
        var widgetCompraLegalGrid = templateManager.container.getWidget('compra_legal_ba_grid');
        
        var cdempresa       = widgetCompraLegalGrid.getParent().currentRow.CDEMPRESA;
        var nrnotafisc      = (!widgetFiltro.NRNOTAFISC) ? "" : widgetFiltro.NRNOTAFISC;  
        var cdfilial        = (!widgetFiltro.CDFILIAL) ? "" : widgetFiltro.CDFILIAL;
        var nrinsjurclie    = (!widgetFiltro.NRINSJURCLIE) ? "" : widgetFiltro.NRINSJURCLIE;
        var cdinscesta      = (!widgetFiltro.CDINSCESTA) ? "" : widgetFiltro.CDINSCESTA;
        var cdinscmuni      = (!widgetFiltro.CDINSCMUNI) ? "" : widgetFiltro.CDINSCMUNI;
        var cdserie         = (!widgetFiltro.CDSERIE) ? "" : widgetFiltro.CDSERIE;
        var cdtipooper      = (!widgetFiltro.CDTIPOOPER) ? "" : widgetFiltro.CDTIPOOPER;
        var dtinicial       = (!widgetFiltro.PERIODO.start) ? "" : widgetFiltro.PERIODO.start;
        var dtfinal         = (!widgetFiltro.PERIODO.end) ? "" : widgetFiltro.PERIODO.end;
        var idnfcompraleg   = (!widgetFiltro.IDSTATUS) ? "" : widgetFiltro.IDSTATUS;
        var vrnotafisc      = (!widgetFiltro.VRNOTAFISC || widgetFiltro.VRNOTAFISC == null) ? 0 :widgetFiltro.currentRow.VRNOTAFISC;
        var nrorg           = getLocalVar('NRORG');
        
        widgetCompraLegalGrid.dataSourceFilter = [];
        
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_CDEMPRESA", operator: "=", value: cdempresa});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_NRNOTAFISC", operator: "=", value: nrnotafisc});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TNRNOTAFISC", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_CDFILIEMIT", operator: "=", value: cdfilial});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TCDFILIEMIT", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_NRINSJURNF", operator: "=", value: nrinsjurclie});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TNRINSJURNF", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_CDINSCESTA", operator: "=", value: cdinscesta});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TCDINSCESTA", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_CDINSCMUNI", operator: "=", value: cdinscmuni});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TCDINSCMUNI", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_CDSERIE", operator: "=", value: cdserie});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TCDSERIE", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_CDTIPOOPER", operator: "=", value: cdtipooper});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_TCDTIPOOPER", operator: "=", value: "T"});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_DTINICIAL", operator: "=", value: dtinicial});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_DTFINAL", operator: "=", value: dtfinal});
        if(idnfcompraleg != 'A')
            widgetCompraLegalGrid.dataSourceFilter.push({name: "P_IDNFCOMPRALEG", operator: "=", value: idnfcompraleg});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "P_VRNOTAFISC", operator: "=", value: vrnotafisc});
        widgetCompraLegalGrid.dataSourceFilter.push({name: "NRORG", operator: "=", value: nrorg});
        
        widgetCompraLegalGrid.reload();
    };
    
    self.exportarArquivo = function(row, route, message) {
        // Inicializa uma promise.
        var deferred = ZHPromise.defer();
        message = message || Messages_fiscal.EXPORTANDO;

        // Muda a mensagem de carregamento para uma mensagem personalizada.
        ScreenService.changeLoadingMessage(message);

        // Chama a rota para efetuar a exportação.
        restEngine.request(route, {"requestType": "Row", "row": row}, undefined, undefined, undefined, undefined, 99999999999999999999)
        .then(function(response) {
            // Cria a rota a ser chamada para o download do arquivo exportado.
            var downloadRoute = window.serviceUrls.filter(function(x){return x.package == 'fis';})[0].baseUrl + "/downloadArquivo?requestType=Row&row[DSARQUIVO]=";
            var fileName = response.dataset.columnsToReturn.fileName;
            
            // Abre a rota em uma nova janela, permitindo que o arquivo seja baixado.
            window.open(downloadRoute + fileName);

            // Finaliza a promise com sucesso.
            deferred.resolve(response);
        })
        .catch(function(error) {
            // Mensagem padrão em caso de timeout.

            // Verifica se houve alguma resposta da requisição.
            if (error.data && error.data.error) {
                // Caso haja alguma resposta, atribui a mensagem de erro.
                errorMessageExport = errorMessageExport+' Erro na inscrição: '+row.inscrestad+'. '+error.data.error+'<br />';
            } else {
                errorMessageExport = errorMessageExport+' Erro na inscrição: '+row.inscrestad+'. '+Messages_fiscal.TIMEOUT_ERROR+'<br />';
            } 

            // Imprime a mensagem.
            //ScreenService.showMessage(errorMessageExport);

            // Finaliza a promise retornando o objeto de erro.
            deferred.reject(error);
        })
        .finally(function() {
            // Restaura a mensagem original.
            ScreenService.restoreDefaultLoadingMessage();
        });

        // Retorna a promise a ser finalizada.
        return deferred;
    };
    
    self.changeNotaFiscalFilter = function(){
        var agendamentoWidget = templateManager.container.getWidget('compra_legal_ba_agendamento');
        var notaFiscalWidget = agendamentoWidget.widgets[0];
        
        notaFiscalWidget.dataSourceFilter.forEach(function(filter, index){
            if(filter.name === 'P_CDEMPRESA'){
                filter.value = agendamentoWidget.currentRow.CDEMPRESA;
            } else if(filter.name === 'P_DTINICIAL'){
                filter.value = agendamentoWidget.currentRow.DTINICIAL.substr(0,10);
            } else if(filter.name === 'P_DTFINAL'){
                filter.value = agendamentoWidget.currentRow.DTFINAL.substr(0,10);
            }
            if(filter.name == 'IDSTATUS'){
                notaFiscalWidget.dataSourceFilter.splice(index); 
            }
        });
        notaFiscalWidget.reload();
        
    };
    
};
Configuration(function(ContextRegister){
    ContextRegister.register("Fis11000_CompraLegalBa_Controller", Fis11000_CompraLegalBa_Controller);
});